import { useEffect, useState } from "react";

const useAnimatedText = (text, delay = 50) => {
  const [animatedText, setAnimatedText] = useState("");

  useEffect(() => {
    let isCancelled = false;

    const animateText = async () => {
      let currentText = ""; // شروع با متن خالی
      for (let i = 0; i < text.length; i++) {
        if (isCancelled) break; // جلوگیری از انیمیشن در صورت لغو
        await new Promise((resolve) => setTimeout(resolve, delay)); // تأخیر
        currentText += text[i]; // افزودن کاراکتر به متن انیمیشن
        setAnimatedText(currentText); // بروزرسانی وضعیت
      }
    };

    if (text && typeof text === "string") {
      animateText();
    } else {
      setAnimatedText(""); // تنظیم متن خالی در صورت نداشتن متن
    }

    return () => {
      isCancelled = true; // جلوگیری از اجرا در زمانی که کامپوننت از بین می‌رود
    };
  }, [text, delay]);

  return animatedText;
};

export default useAnimatedText;
